<template>
  <div class="w-100">
    <v-sheet v-if="!initialized && loading" color="grey lighten-4 " class="px-3 pt-3 pb-12">
          <v-responsive
      max-width="100%"
      class="mx-auto"
    >
      <v-skeleton-loader
        ref="skeleton"
        type="table"
        class="mx-auto"
      ></v-skeleton-loader>
       </v-responsive>
    </v-sheet>
    <v-data-table v-else
      :headers="headers"
      v-model="selected"
      show-select
      item-key="name"
      :items="items"
      :single-select="singleSelect"
      sort-by="created_at"
      
      :search="search"
      show-expand
      :single-expand="singleExpand"
      :expanded.sync="expanded"
      class="elevation-1 w-100" 
    >
    <template v-slot:item.base_price="{ item }">
       <span v-if="item.base_price">
         {{  formatMoney(item.base_price)+"F CFA" }}
       </span>
       
    </template>

    <template v-slot:item.examtype="{ item }">
       {{ item.examtype ? item.examtype.label : "Non precisé" }}
    </template>
    
    <template v-slot:expanded-item="{ headers, item }">
      <td :colspan="headers.length">
        <!-- <span v-for="(insurance,key) in item.insurances" :key="key"> -->
        <v-simple-table>
          <template v-slot:default>
            <thead>
              <tr>
                <th :colspan="headers.length" class="text-left">Nom de l'assurance</th>
                <th :colspan="headers.length" class="text-left">TM</th>
                <th :colspan="headers.length" class="text-left">GAP</th>
                <th :colspan="headers.length" class="text-left">GAP TM</th>
              </tr>
            </thead>
            <tbody>
              <tr v-for="(insurance,key) in item.insurances" :key="key">
                <td :colspan="headers.length">{{ insurance.name }}</td>
                <td :colspan="headers.length">{{ formatMoney(insurance.pivot.tm)+" F CFA" }}</td>
                <td :colspan="headers.length">{{ formatMoney(insurance.pivot.gap)+" F CFA" }}</td>
                <td :colspan="headers.length">{{ formatMoney(insurance.pivot.gap_tm)+" F CFA" }}</td>
              </tr>
            </tbody>
          </template>
        </v-simple-table>
        </td>
    </template>

    <template v-slot:top>
      <v-toolbar flat color="white">

          <v-dialog v-model="dialog" max-width="900px">
          <template v-slot:activator="{ on, attrs }">
                            <v-card-title  class="w-100">
                    Examens

                      <v-btn small
                            color="secondary"
                            dark
                            class="mb-2 ml-2"
                            v-bind="attrs"
                            v-on="on"
                            >Nouveau
                      </v-btn>
                      <v-spacer></v-spacer>
                            <v-text-field
                                v-model="search"
                                class="mb-2"
                                append-icon="mdi-magnify"
                                label="Recherche"
                                single-line
                                hide-details
                        ></v-text-field>
                </v-card-title>

          </template>
          <v-card>

               <v-card-title>
                  <span class="headline">{{ formTitle }}</span>
                            <v-spacer></v-spacer>
          <v-menu bottom left>
            <template v-slot:activator="{ on, attrs }">
                            <v-btn  small  @click="addInsurance"  color="secondary" dark>
                              Ajouter un tarif d'assurance
                            </v-btn>
            </template>
          </v-menu>
                </v-card-title>

            <v-card-text>
              <v-container>
               <ValidationObserver class="w-100" ref="form" v-slot="{ invalid  }">
                <v-row>
                  <v-col cols="12" sm="6" md="6">
                    <ValidationProvider :custom-messages="errorMessages.name" v-slot="{ errors }" name="name" rules="required">
                            <v-text-field
                              label="Nom de l'examen"
                              v-model="editedItem.name"
                              clearable
                              :error-messages="errors"
                              outlined
                            ></v-text-field>
                    </ValidationProvider>
                    <!-- <v-text-field v-model="editedItem.name" label="Nom"></v-text-field> -->
                  </v-col> 
                  <v-col cols="12" sm="6" md="6">
                    <ValidationProvider :custom-messages="errorMessages.base_price" v-slot="{ errors }" name="base_price" rules="required">
                      <v-text-field
                      
                        label="Prix de base"
                        v-model="editedItem.base_price"
                        clearable
                        :error-messages="errors"
                        outlined>
                        </v-text-field>
                    </ValidationProvider>
                  </v-col>
                  
                  <v-col cols="12" sm="6" md="6">
                   <ValidationProvider :custom-messages="errorMessages.exam_type_id" v-slot="{ errors }" name="exam_type_id" rules="required">
                    <v-select
                      v-model="editedItem.exam_type_id"
                      :items="exam_types"
                      :error-messages="errors"
                      item-value="id"
                      item-text="label"
                      label="Type d'examens"                    
                      clearable
                    ></v-select>
                    </ValidationProvider>

                    <!-- <v-select v-model="editedItem.exam_types" :items ="exam_types" :rules="[v => !!v || 'Ce champs est requis']" label="Type d'examens" required></v-select> -->
                  </v-col>
                   <v-col cols="12" sm="6" md="6">
                   <ValidationProvider :custom-messages="errorMessages.result_type_id" v-slot="{ errors }" name="result_type_id" rules="required">
                    <v-select
                      v-model="editedItem.result_type_id"
                      :items="result_types"
                      :error-messages="errors"
                      item-value="id"
                      item-text="label"
                      label="Type de résultat"                    
                      clearable
                    ></v-select>
                    </ValidationProvider>
                    <!-- <v-select v-model="editedItem.exam_types" :items ="exam_types" :rules="[v => !!v || 'Ce champs est requis']" label="Type d'examens" required></v-select> -->
                  </v-col>
                </v-row>
                <v-row>

                  <v-container>
                  <v-row v-for="(insurance,key) in editedItem.insurances" :key="key">
                    <div class="row v-row-exam bloc-insurance">
                     <v-col cols="12" sm="4" md="4">
                     <ValidationProvider :custom-messages="errorMessages.insurance_id" v-slot="{ errors }" :name="'insurances.'+key+'.insurance_id'" rules="required">
                      <v-select
                        v-model="editedItem.insurances[key].id"
                        :items="assuranceDisponible"
                        item-value="id"
                        item-text="name"
                        label="Assurances"
                        :error-messages="errors"
                        clearable
                        :block="true"
                      ></v-select>
                      </ValidationProvider>
                    </v-col>
                    <!-- <v-col cols="12" sm="5" md="3">
                        <v-text-field clearable disabled v-model="editItem.insurance" label="Assurance"></v-text-field>
                    </v-col> -->
                    <v-col cols="12" sm="2" md="2">
                       <ValidationProvider :custom-messages="errorMessages.insurance_cotation" v-slot="{ errors }" :name="'insurances.'+key+'.pivot.price'" rules="required">
                           <v-text-field 
                           :error-messages="errors"
                           clearable v-model="editedItem.insurances[key].pivot.price" label="Cotation"></v-text-field>
                       </ValidationProvider>
                    </v-col>
                    <v-col cols="12" sm="2" md="2">
                        <ValidationProvider :custom-messages="errorMessages.insurance_tm" v-slot="{ errors }" :name="'insurances.'+key+'.pivot.tm'" :rules="required">
                        <v-text-field :error-messages="errors" clearable v-model="editedItem.insurances[key].pivot.tm" label="TM"></v-text-field>
                       </ValidationProvider>
                    </v-col>
                    <v-col cols="12" sm="2" md="2">
                       <ValidationProvider :custom-messages="errorMessages.insurance_gap" v-slot="{ errors }" :name="'insurances.'+key+'.pivot.gap'" rules="required">
                        <v-text-field :error-messages="errors" clearable v-model="editedItem.insurances[key].pivot.gap" label="GAP"></v-text-field>
                      </ValidationProvider>
                    </v-col>
                    <v-col cols="12" sm="2" md="2">
                      <ValidationProvider :custom-messages="errorMessages.insurance_tm_gap" v-slot="{ errors }" :name="'insurances.'+key+'.pivot.tm_gap'" rules="required">
                        <v-text-field :error-messages="errors" clearable v-model="editedItem.insurances[key].pivot.gap_tm" label="TM GAP"></v-text-field>
                      </ValidationProvider>
                    </v-col>
                        <v-btn @click="removeInsurance(key)" class="mx-2 bloc-insurance-close" fab dark x-small color="red">
                            <v-icon dark>mdi-close</v-icon>
                         </v-btn>
                    </div>

                  </v-row>
                  </v-container>

                </v-row>
              </ValidationObserver>
              </v-container>
            </v-card-text>

            <v-card-actions>
              <v-spacer></v-spacer>
              <v-btn color="secondary" dark @click="close">Annuler</v-btn>
              <v-btn color="info" :disabled="invalid" flat @click="save">{{ formTextButton }}</v-btn>
            </v-card-actions>
          </v-card>
        </v-dialog>
        <v-spacer></v-spacer>

      </v-toolbar>
    </template>
    <template v-slot:item.actions="{ item }">
      <v-icon
        small
        class="mr-2"
        @click="editItem(item)"
      >
        mdi-pencil
      </v-icon>
      <v-icon
        small
        @click="deleteItem(item)"
      >
        mdi-delete
      </v-icon>
    </template>
    <template v-slot:no-data>
      <!-- <v-btn color="primary" @click="initialize">Reset</v-btn> -->
    </template>
    <template v-slot:left>
      <v-switch v-model="singleSelect" label="Single select" class="pa-3"></v-switch>
    </template>
  </v-data-table>
  </div>
</template>

<script>
  
  import { mapGetters } from 'vuex'
import * as rules from 'vee-validate/dist/rules'
import { extend, ValidationProvider, ValidationObserver } from "vee-validate";

Object.keys(rules).forEach(rule => {
  extend(rule, rules[rule]);
});

  extend('required', {
    ...rules['required'],
    message: '{_field_} can not be empty',
  })
  extend('date_gtt', value => 
  {
    //on recupere la date
    var current = moment()

    var d = moment(value)

    var diff = current.diff(d)
    //on verifie que la date n'est pas anterieure à la date courante
    return diff > 0

});
  extend('date', value => 
  {
    var dateReg = /^\d{4}([-])\d{2}([-])\d{2}$/
    //on recupere la date

    //on verifie que la date n'est pas anterieure à la date courante
    return  value.match(dateReg)

});
  export default {
        components: {
      ValidationProvider,
      ValidationObserver,
    },
    data: () => ({
      dataFilters: {},
      search: '',
      dialog: false,
      edit:false,
      singleSelect: false,
      selected: [],
      expanded: [],
      singleExpand: false,
      gridConfig: {
        records: [],
        loading: true,
        options: {
          itemsPerPageOptions: [10, 25, 50, 100],
          totalPages: 0,
          itemsPerPage: 10,
          page: 1,
          descending: false,
        }
      },
      headers: [
        {
          text: 'Examen (s)',
          align: 'left',
          sortable: true,
          value: 'name',
        },
        { text: 'Prix de base', value: 'base_price' },
        { text: "Type d'examen", value: 'examtype' },
        { text: 'Assuré ?', value: 'data-table-expand' },
        { text: 'Actions', value: 'actions', sortable: false },
      ],
                      errorMessages:
                  {
                    name : 
                    {
                      required: 'Le nom est requis',

                    },
                    base_price:
                    {
                      required:'Le prix de base est requis'
                    },
                    exam_type_id:
                    {
                      required:'Le type d\'examen est requis'
                    },
                    result_type_id:
                    {
                      required:'Le type de resultat est requis'
                    },
                    cotation:
                    {
                      required:'La cotation est requise'
                    },
                    insurance_id:
                    {
                      required:'L\'assurance est requise'
                    },
                    insurance_cotation:
                    {
                      required:"Le n° de l'assurance est requis",
                    },
                    insurance_tm:
                    {
                      required:"Le n° de l'assurance est requis",
                    },
                    insurance_gap:
                    {
                      required:"Le nom de l'assuré est requis",
                    },
                    insurance_tm_gap:
                    {
                      required:"Le nom de l'assuré est requis",
                    }
                  }
                ,
      desserts: [],
      editedIndex: -1,
      editedItem: {
        name: '',
        base_price: 0,
        assurance: '',
        TM: '',
        GAP: '',
        exam_type_id : '',
        result_type_id : '',
        insurances: [
  
        ],
        assurances_choose: []
      },
      defaultItem: {
        name: '',
        base_price: 0,
        assurance: '',
        TM: '',
        GAP: '',
        exam_type_id : '',
        insurances: [],
        result_type_id:'',
        assurances_choose: []
      },
    }),

    computed: {
       ...mapGetters({initialized:'examens/initialized', exam_types:"params/_exam_types", result_types:"params/_result_types", insurances:"params/_insurances", moreExists:'examens/moreExists',next_page_url:"examens/next_page_url",total:"examens/total"
                           ,current_page:"examens/current_page",items:"examens/_items",loading:"examens/loading",loaded:"examens/loaded"}),

      formTitle () {
        return this.editedIndex === -1 ? "Nouvel examen" : "Modification de l'examen"
      },

      formTextButton(){
        return this.editedIndex === -1 ? "Enregistrer" : "Modifier"
      },
         assuranceDisponible(){
           //puis les assurances qui le couvrent
           var i =_.map(this.editedItem.insurances,'id') 
           var accepted = this.insurances.filter(e =>{
              return !i.indexOf(e.id) > -1;
            })
            return accepted
    },
    },

 

    watch: {
      dialog (val) {
        val || this.close()
      },
    },

    created () {
      // this.initialize()
    //  window.event.$emit("isLoading",true)
      this.$store.dispatch('examens/init')
      this.$store.dispatch('examens/getExamens')
    },

    methods: {
      addExamen () {

      },

      onChange(assurance){
        this.chooseOnlyOneInsurance(assurance);
      },

      formatMoney(num , localize,fixedDecimalLength){
          num=num+"";
          var str=num;
          var reg=new RegExp(/(\D*)(\d*(?:[\.|,]\d*)*)(\D*)/g)
          if(reg.test(num)){ 
            var pref=RegExp.$1;
            var suf=RegExp.$3;
            var part=RegExp.$2;
              if(fixedDecimalLength/1)part=(part/1).toFixed(fixedDecimalLength/1);
                if(localize)part=(part/1).toLocaleString();
                  str= pref +part.match(/(\d{1,3}(?:[\.|,]\d*)?)(?=(\d{3}(?:[\.|,]\d*)?)*$)/g ).join(' ')+suf ;
          };
        return str;
      },

      editItem (item) {
        this.edit = true
        this.editedIndex = this.items.indexOf(item)
        this.editedItem = Object.assign({}, item)
        this.dialog = true
        
      },

     deleteItem (item) {
       confirm("Voulez-vous supprimer cette entreprise ?")
       
        this.$store.dispatch('examens/removeExamen',item)
      },

      close () {
        this.dialog = false
        this.edit = false
        this.$nextTick(() => {
          this.$refs.form.reset()
          this.editedItem = Object.assign({}, this.defaultItem)
          this.editedIndex = -1
        })
      },

      save () {

          this.$store.dispatch(!this.edit? "examens/addExamen" : "examens/updateExamen", this.editedItem).then((response) =>
            {
              flash(this.edit ? "Examen modifié" :'Nouvel examen ajouté')
               this.close()
            },
            (error) => 
            {
              alert('erreur')
                       if(this.$refs.form)
                       {
                         console.log(this.$refs.form)
                                                this.$refs.form.setErrors(error.response.data.errors)

                       }
                    });
      },

      //Ajoute une assurance temporaire
       addInsurance ()
       {
         this.editedItem.insurances.push({id: "",pivot:{price:'' ,tm:"",gap:"", tm_gap: ""}})


       },
        //Retire une assurance de la liste
       removeInsurance (key)
       {
         this.editedItem.insurances.splice(key,1)
       },
    },
  }
</script>
<style lang="scss" scoped>
  .bloc-insurance{
    position: relative;
        border: 1px solid #c9c9c966;
        margin-top: 10px;
  }
    .bloc-insurance-close {
    position: absolute;
right: -10px;
    top: -15px;

  }
</style>